extends ../layout

block scripts
    script(src='/css/demo/default/custom/crud/forms/widgets/select2.js' type='text/javascript')
    script(src='https://cdn.plot.ly/plotly-latest.js' type='text/javascript')
    script(type='text/javascript').
      $("#m_select2").select2({ width: '275px' });
      $("#m_select3").select2({ width: '275px' });

      function removeA(arr) {
        var what, a = arguments, L = a.length, ax;
        while (L > 1 && arr.length) {
          what = a[--L];
          while ((ax = arr.indexOf(what)) !== -1) {
            arr.splice(ax, 1);
          }
        }
        return arr;
      }

        var employeesData = JSON.parse(("#{employeesJs.employees}").replace(/&quot;/g,'"'));
        var employeesDataRevs = JSON.parse(("#{employeesJs.employeesRevs}").replace(/&quot;/g,'"'));

        console.log('Reviews', employeesDataRevs);

        var selectedRight = [];
        var selectedLeft = [];
        var calculatedRight = { reviews: [] };
        var calculatedLeft = { reviews: [] };

          // establish data for charts and general stats
          var selectionLeftChartData = {};
          var selectionRightChartData = {};
          var rx = [];
          var lx = [];
          var ry = [];
          var ly = [];
          var rt = [];
          var lt = [];

      $('#rightAdd').on('click', function(e) {
        e.preventDefault();
        var selectedEmployee = $('#m_select2').val();
        var appendBox = $('#m_widget2_tab1_content').children()[0];
        if ( $('#info1') ) {
          $('#info1').remove();
        }
        for (let i = 0; i < employeesData.length; i++) {
          if (employeesData[i]._id === selectedEmployee) {
            var employeeBox = '<div class="m-widget2__item m-widget2__item--primary">' +
                '<div class="m-widget2__checkbox"><span data-employee_id=' + employeesData[i]._id + '></span></div>' +
                '<div class="m-widget2__desc"><span class="m-widget2__text">'+ employeesData[i].role.name +' | ' + employeesData[i].email + '</span><br/><span class="m-widget2__user-name"><a class="m-widget2__link" href="#">' + employeesData[i].profile.name + '</a></span></div>' +
                '<div class="m-widget2__actions">' +
                '<div class="m-widget2__actions-nav"><button class="remover btn m-btn m-btn--hover-danger m-btn--icon m-btn--icon-only m-btn--pill"><i class="flaticon flaticon-delete"></i></button></div>' +
                '</div>' +
                '</div>';
            var parser = new DOMParser();
            var newNode = parser.parseFromString(employeeBox, "text/html");
            appendBox.appendChild(newNode.documentElement);
            selectedLeft.push(employeesData[i]._id);
          }
          var remover = $('.remover');
          remover.click(function (e) {
            e.preventDefault();
            this.parentElement.parentElement.parentElement.remove();
            removeA(selectedLeft, employeesData[i]._id);
            console.log('removing: ', employeesData[i]._id);
            console.log('left selected: ', selectedLeft);
            if (!$('#info1')) {
              var infoDom = '<div class="m-widget2__item m-widget2__item--warning" id="info1">' +
                  '<div class="m-widget2__checkbox"><span class="m--align-center">Your employees will be listed here, select an employee and add them</span></div>' +
                  '</div>';
              var newInfo = parser.parseFromString(infoDom, 'text/html');
              appendBox.appendChild(newInfo.documentElement);
            }
          });
        }
      });

      $('#leftAdd').on('click', function (e) {
        e.preventDefault();
        var selectedEmployee = $('#m_select3').val();
        var appendBox = $('#m_widget2_tab2_content').children()[0];
        if ($('#info2')) {
          $('#info2').remove();
        }
        for (let i = 0; i < employeesData.length; i++) {
          if (employeesData[i]._id === selectedEmployee) {
            var employeeBox = '<div class="m-widget2__item m-widget2__item--warning">' +
                '<div class="m-widget2__checkbox"><span data-employee_id=' + employeesData[i]._id + '></span></div>' +
                '<div class="m-widget2__desc"><span class="m-widget2__text">' + employeesData[i].role.name + ' | ' + employeesData[i].email + '</span><br/><span class="m-widget2__user-name"><a class="m-widget2__link" href="#">' + employeesData[i].profile.name + '</a></span></div>' +
                '<div class="m-widget2__actions">' +
                '<div class="m-widget2__actions-nav"><button class="remover btn m-btn m-btn--hover-danger m-btn--icon m-btn--icon-only m-btn--pill"><i class="flaticon flaticon-delete"></i></button></div>' +
                '</div>' +
                '</div>';
            var parser = new DOMParser();
            var newNode = parser.parseFromString(employeeBox, "text/html");
            appendBox.appendChild(newNode.documentElement);
            selectedRight.push(employeesData[i]._id);
          }
          var remover = $('.remover');
          remover.click(function (e) {
            e.preventDefault();
            this.parentElement.parentElement.parentElement.remove();
            removeA(selectedRight, employeesData[i]._id)
            console.log('removing: ', employeesData[i]._id);
            console.log('left selected: ', selectedLeft);
            if (!$('#info2')) {
              var infoDom = '<div class="m-widget2__item m-widget2__item--warning" id="info2">' +
                  '<div class="m-widget2__checkbox"><span class="m--align-center">Your employees will be listed here, select an employee and add them</span></div>' +
                  '</div>'
              var newInfo = parser.parseFromString(infoDom, 'text/html');
              appendBox.appendChild(newInfo.documentElement);
            }

          });
        }
      });

      $('#load').on('click', function(e) {
        e.preventDefault();
        function chartDataSerializer(array) {
          if (array.length < 1) {
            return 0;
          }

          function pad(n) {
            return n.toString().length === 1 ? `0${n}` : n;
          }

          var obj = {
            gradeSum: [],
            count: [],
            productivity: [],
            date: []
          };
          var result = [];

          for (var i = 0; i < array.length; i++) {
            var thisDate = new Date(array[i].createdAt);
            var day = pad(thisDate.getDate());
            var month = pad(thisDate.getMonth() + 1);
            var year = thisDate.getFullYear();
            var key = [year, day, month].join('-');
            var productivity = array[i].data.productivity;

            obj.productivity[key] = obj.productivity[key] || '';
            obj.productivity[key] += productivity;
            obj.gradeSum[key] = obj.gradeSum[key] || 0;
            obj.gradeSum[key] += array[i].data.grade;
            obj.count[key] = obj.count[key] || 0;
            obj.count[key]++;
            obj.date[key] = obj.date[key] || '';
            obj.date[key] += key;
          }
          var cou = 0;
          Object.keys(obj.count).forEach(function (key) {
            result[cou] = {
              date: obj.date[key],
              performance: obj.productivity[key],
              average: (obj.gradeSum[key] / obj.count[key]).toFixed(1)
            };
            cou = cou + 1;
          });

          return result;
        }

        // Serialize selected employees in left group
        selectedLeft.map(function (key) {
          employeesDataRevs.forEach(function(entry) {
            if(entry[key] !== undefined) {
                calculatedLeft.reviews.push(entry[key]);
            }
          });
        });


        // Serialize selected employees in right group
        selectedRight.map(function (key) {
          employeesDataRevs.forEach(function (entry) {
            if (entry[key] !== undefined) {
              calculatedRight.reviews.push(entry[key]);
            }
          });
        });

        // Left group serialization through x,y axis, and text array of messages.
        if (calculatedLeft.reviews.length > 0 && calculatedLeft.reviews[0].length > 0) {
          selectionLeftChartData.reviews = chartDataSerializer(calculatedLeft.reviews[0]);
          console.log('selection left chart data: ', selectionLeftChartData);
          for (var i = 0; i < selectionLeftChartData.reviews.length; i++) {
            lx.push(selectionLeftChartData.reviews[i].date);
            ly.push(selectionLeftChartData.reviews[i].average);
            lt.push(selectionLeftChartData.reviews[i].performance);
          }
        } else {
          selectionLeftChartData.reviews = [];
        }

        // Right group serialization through x,y axis, and text array of messages.
        if (calculatedRight.reviews.length > 0 && calculatedRight.reviews[0].length > 0) {
          console.log('left out reviews: ', calculatedRight.reviews);
          selectionRightChartData.reviews = chartDataSerializer(calculatedRight.reviews[0]);
          console.log('selection right chart data: ', selectionRightChartData);
          for (var j = 0; j < selectionRightChartData.reviews.length; j++) {
            ry.push(selectionRightChartData.reviews[j].average);
            rx.push(selectionRightChartData.reviews[j].date);
            rt.push(selectionRightChartData.reviews[j].performance);
          }

        } else {
          selectionRightChartData.reviews = [];
        }

        console.log('right: ', rx, ry, rt);
        console.log('left: ', lx, ly, lt);
        var trace1Reviews = {
          name: 'Reviews Left',
          x: lx,
          y: ly,
          type: 'bar',
          text: lt,
          marker: {
            color: '#5867dd'
          }
        };

        var trace2Reviews = {
          name: 'Reviews Right',
          x: rx,
          y: ry,
          type: 'bar',
          text: rt,
          marker: {
            color: '#ffb822'
          }
        };

        var data = [trace1Reviews, trace2Reviews];

        var layout = {
          font: {
            family: 'Raleway, sans-serif'
          },
          showlegend: false,
          xaxis: {
            tickangle: -45
          },
          yaxis: {
            zeroline: false,
            gridwidth: 2
          },
          bargap: 0.05,
          barmode: "group"
        };

        Plotly.newPlot('reviews', data, layout, {responsive: true});

        var totalAverageGradeL = 0;
        var s = 0;
        for (s; s < ly.length; s++) {
          totalAverageGradeL += Number(ly[s]);
        }
        console.log(totalAverageGradeL);
        totalAverageGradeL = totalAverageGradeL / s;
        $('#TotalAverageGradeL')[0].childNodes[0].data = totalAverageGradeL.toFixed(1);
        $('#ReviewsCountL')[0].childNodes[0].data = s;

        var totalAverageGradeR = 0;
        var f = 0;
        for (f; f < ry.length; f++) {
          totalAverageGradeR += Number(ry[f]);
        }
        totalAverageGradeR = totalAverageGradeR / f;
        console.log(totalAverageGradeR);

        $('#TotalAverageGradeR')[0].childNodes[0].data = totalAverageGradeR.toFixed(1);
        $('#ReviewsCountR')[0].childNodes[0].data = f;

      });

      $('#reset').on('click', function(e) {
        e.preventDefault();

        $('#TotalAverageGradeL')[0].childNodes[0].data = 0;
        $('#ReviewsCountL')[0].childNodes[0].data = 0;

        $('#TotalAverageGradeR')[0].childNodes[0].data = 0;
        $('#ReviewsCountR')[0].childNodes[0].data = 0;

        var trace1 = {
          name: 'Group Left',
          x: [],
          y: [],
          type: 'bar',
          text: [],
          marker: {
            color: '#5867dd'
          }
        };

        var trace2 = {
          name: 'Group Right',
          x: [],
          y: [],
          type: 'bar',
          text: [],
          marker: {
            color: '#ffb822'
          }
        };

        var data = [trace1, trace2];

        var layout = {
          font: {
            family: 'Raleway, sans-serif'
          },
          showlegend: false,
          xaxis: {
            tickangle: -45
          },
          yaxis: {
            zeroline: false,
            gridwidth: 2
          },
          bargap: 0.05,
          barmode: "group"
        };

        Plotly.newPlot('reviews', data, layout, {responsive: true});
      });

      $('#TotalAverageGradeL')[0].childNodes[0].data = 0;
      $('#ReviewsCountL')[0].childNodes[0].data = 0;

      $('#TotalAverageGradeR')[0].childNodes[0].data = 0;
      $('#ReviewsCountR')[0].childNodes[0].data = 0;

      var trace1 = {
        name: 'Group Left',
        x: [],
        y: [],
        type: 'bar',
        text: [],
        marker: {
          color: '#5867dd'
        }
      };

      var trace2 = {
        name: 'Group Right',
        x: [],
        y: [],
        type: 'bar',
        text: [],
        marker: {
          color: '#ffb822'
        }
      };

      var data = [trace1, trace2];

      var layout = {
        font: {
          family: 'Raleway, sans-serif'
        },
        showlegend: false,
        xaxis: {
          tickangle: -45
        },
        yaxis: {
          zeroline: false,
          gridwidth: 2
        },
        bargap: 0.05,
        barmode: "group"
      };

      Plotly.newPlot('reviews', data, layout, {responsive: true});


block content
    .m-content
        .row
            .col-xl-6
                // begin:: Widgets/Tasks
                .m-portlet.m-portlet--full-height
                    .m-portlet__head
                        .m-portlet__head-tools
                            select#m_select2.form-control.m-select2(name='employee' width="275px")
                                option(value=0) select employee
                                each employee in employees
                                    option(value=employee._id) #{employee.profile.name} | #{employee.role.name}
                        .m-portlet__head-tools
                            button#rightAdd.btn.btn-primary Add
                    .m-portlet__body
                        .tab-content
                            #m_widget2_tab1_content.tab-pane.active
                                .m-widget2
                                    #info1.m-widget2__item.m-widget2__item--primary
                                        .m-widget2__checkbox
                                            span.m--align-center Your employees will be listed here, select an employee and add them in group
                // end:: Widgets/Tasks
            .col-xl-6
                // begin:: Widgets/Support Tickets
                .m-portlet.m-portlet--full-height
                    .m-portlet__head
                        .m-portlet__head-tools
                            button#leftAdd.btn.btn-primary Add
                        .m-portlet__head-tools
                            select#m_select3.form-control.m-select2(name='employee' width="275px")
                                option(value=0) select employee
                                each employee in employees
                                    option(value=employee._id) #{employee.profile.name} | #{employee.role.name}
                    .m-portlet__body
                        .tab-content
                            #m_widget2_tab2_content.tab-pane.active
                                .m-widget2
                                    #info2.m-widget2__item.m-widget2__item--warning
                                        .m-widget2__checkbox
                                            span.m--align-center Your employees will be listed here, select an employee and add them in group
                                    //.m-widget2__item.m-widget2__item--warning
                                    //    .m-widget2__checkbox
                                    //        span
                                    //    .m-widget2__desc
                                    //        span.m-widget2__text
                                    //            | Web Developer | hadzicismar67@gmail.com
                                    //        br
                                    //        span.m-widget2__user-name
                                    //            a.m-widget2__link(href='#')
                                    //                | Ismar Hadzic
                                    //    .m-widget2__actions
                                    //        .m-widget2__actions-nav
                                    //            button.btn.m-btn.m-btn--hover-danger.m-btn--icon.m-btn--icon-only.m-btn--pill
                                    //                i.flaticon.flaticon-delete
                // end:: Widgets/Support Tickets
            .col-xl-12
                .row
                    .col-xl-12
                        .m-portlet.m-portlet--full-height
                            .m-portlet__body
                                span Reviews
                                div
                                    #reviews(style='height:500px;')
                .row
                    .col-xl-12
                        .m-portlet.m-portlet--full-height
                            .m-portlet__body.align-content-center.m--align-center
                                h2 Total Stats
                                span general
                                .row
                                    .col-xl-6
                                        h3 Selection Left
                                        span Reviews Total Average Grade
                                        p
                                            b#TotalAverageGradeL 7.9
                                        span Reviews Count
                                        p
                                            b#ReviewsCountL 17
                                    .col-xl-6
                                        h3 Selection Right
                                        span Reviews Total Average Grade
                                        p
                                            b#TotalAverageGradeR 5.4
                                        span Reviews Count
                                        p
                                            b#ReviewsCountR 21
                                .row
                                    .col-xl-12
                                        button#load.btn.btn-brand Submit
                                        button#reset.btn.btn-warning Reset Stats